<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Example Usage &mdash; PyArg  documentation</title>
      <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
        <script src="_static/jquery.js"></script>
        <script src="_static/underscore.js"></script>
        <script src="_static/doctools.js"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="PyArg Module Overview" href="modules.html" />
    <link rel="prev" title="Installation instructions" href="installation.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="index.html" class="icon icon-home"> PyArg
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="installation.html">Installation instructions</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">Example Usage</a></li>
<li class="toctree-l1"><a class="reference internal" href="modules.html">PyArg Module Overview</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">PyArg</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="index.html" class="icon icon-home"></a> &raquo;</li>
      <li>Example Usage</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/example_usage.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="example-usage">
<h1>Example Usage<a class="headerlink" href="#example-usage" title="Permalink to this headline"></a></h1>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">unittest</span>

<span class="kn">from</span> <span class="nn">py_arg.aspic_classes.argumentation_system</span> <span class="kn">import</span> <span class="n">ArgumentationSystem</span>
<span class="kn">from</span> <span class="nn">py_arg.aspic_classes.argumentation_theory</span> <span class="kn">import</span> <span class="n">ArgumentationTheory</span>
<span class="kn">from</span> <span class="nn">py_arg.aspic_classes.defeasible_rule</span> <span class="kn">import</span> <span class="n">DefeasibleRule</span>
<span class="kn">from</span> <span class="nn">py_arg.aspic_classes.orderings.elitist_ordering</span> <span class="kn">import</span> <span class="n">ElitistOrdering</span>
<span class="kn">from</span> <span class="nn">py_arg.aspic_classes.orderings.last_link_ordering</span> <span class="kn">import</span> <span class="n">LastLinkElitistOrdering</span><span class="p">,</span> <span class="n">LastLinkDemocraticOrdering</span>
<span class="kn">from</span> <span class="nn">py_arg.aspic_classes.literal</span> <span class="kn">import</span> <span class="n">Literal</span>
<span class="kn">from</span> <span class="nn">py_arg.aspic_classes.ordinary_premise</span> <span class="kn">import</span> <span class="n">OrdinaryPremise</span>
<span class="kn">from</span> <span class="nn">py_arg.aspic_classes.preference</span> <span class="kn">import</span> <span class="n">Preference</span>
<span class="kn">from</span> <span class="nn">py_arg.aspic_classes.strict_rule</span> <span class="kn">import</span> <span class="n">StrictRule</span>
<span class="kn">from</span> <span class="nn">py_arg.aspic_classes.orderings.weakest_link_ordering</span> <span class="kn">import</span> <span class="n">WeakestLinkElitistOrdering</span><span class="p">,</span> \
    <span class="n">WeakestLinkDemocraticOrdering</span>
<span class="kn">from</span> <span class="nn">py_arg.aspic_classes.instantiated_argument</span> <span class="kn">import</span> <span class="n">InstantiatedArgument</span>


<span class="k">def</span> <span class="nf">get_argumentation_theory</span><span class="p">(</span><span class="n">include_d</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span><span class="p">,</span> <span class="n">include_e</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">ArgumentationTheory</span><span class="p">:</span>
    <span class="n">literal_str_list</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;a&#39;</span><span class="p">,</span> <span class="s1">&#39;p&#39;</span><span class="p">,</span> <span class="s1">&#39;q&#39;</span><span class="p">,</span> <span class="s1">&#39;r&#39;</span><span class="p">,</span> <span class="s1">&#39;s&#39;</span><span class="p">,</span> <span class="s1">&#39;t&#39;</span><span class="p">]</span>

    <span class="k">if</span> <span class="n">include_d</span><span class="p">:</span>
        <span class="n">literal_str_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="s1">&#39;d&#39;</span><span class="p">)</span>

    <span class="n">literal_str_list</span> <span class="o">+=</span> <span class="p">[</span><span class="s1">&#39;-&#39;</span> <span class="o">+</span> <span class="n">literal_str</span> <span class="k">for</span> <span class="n">literal_str</span> <span class="ow">in</span> <span class="n">literal_str_list</span><span class="p">]</span>
    <span class="n">literal_str_list</span> <span class="o">+=</span> <span class="p">[</span><span class="s1">&#39;~&#39;</span> <span class="o">+</span> <span class="n">literal_str</span> <span class="k">for</span> <span class="n">literal_str</span> <span class="ow">in</span> <span class="n">literal_str_list</span><span class="p">]</span>

    <span class="n">language</span> <span class="o">=</span> <span class="p">{</span><span class="n">literal_str</span><span class="p">:</span> <span class="n">Literal</span><span class="p">(</span><span class="n">literal_str</span><span class="p">,</span> <span class="n">literal_str</span> <span class="o">+</span> <span class="s1">&#39; is present&#39;</span><span class="p">,</span> <span class="n">literal_str</span> <span class="o">+</span> <span class="s1">&#39; is absent&#39;</span><span class="p">)</span>
                <span class="k">for</span> <span class="n">literal_str</span> <span class="ow">in</span> <span class="n">literal_str_list</span><span class="p">}</span>

    <span class="n">contraries</span> <span class="o">=</span> <span class="p">{</span><span class="n">literal_str</span><span class="p">:</span> <span class="p">[]</span> <span class="k">for</span> <span class="n">literal_str</span> <span class="ow">in</span> <span class="n">language</span><span class="o">.</span><span class="n">keys</span><span class="p">()}</span>
    <span class="k">for</span> <span class="n">literal_str</span> <span class="ow">in</span> <span class="n">language</span><span class="o">.</span><span class="n">keys</span><span class="p">():</span>
        <span class="k">if</span> <span class="n">literal_str</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="ow">in</span> <span class="p">(</span><span class="s1">&#39;~&#39;</span><span class="p">,</span> <span class="s1">&#39;-&#39;</span><span class="p">):</span>
            <span class="n">contraries</span><span class="p">[</span><span class="n">literal_str</span><span class="p">]</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">language</span><span class="p">[</span><span class="n">literal_str</span><span class="p">[</span><span class="mi">1</span><span class="p">:]])</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">contraries</span><span class="p">[</span><span class="n">literal_str</span><span class="p">]</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;-&#39;</span> <span class="o">+</span> <span class="n">literal_str</span><span class="p">])</span>

    <span class="n">strict_rules</span> <span class="o">=</span> <span class="p">[</span><span class="n">StrictRule</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;t&#39;</span><span class="p">],</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;q&#39;</span><span class="p">]},</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;-p&#39;</span><span class="p">],</span> <span class="s1">&#39;r1&#39;</span><span class="p">)]</span>

    <span class="n">d1</span> <span class="o">=</span> <span class="n">DefeasibleRule</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;~s&#39;</span><span class="p">]},</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;t&#39;</span><span class="p">],</span> <span class="s1">&#39;d1&#39;</span><span class="p">)</span>
    <span class="n">d2</span> <span class="o">=</span> <span class="n">DefeasibleRule</span><span class="p">(</span><span class="mi">2</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;r&#39;</span><span class="p">]},</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;q&#39;</span><span class="p">],</span> <span class="s1">&#39;d2&#39;</span><span class="p">)</span>
    <span class="n">d3</span> <span class="o">=</span> <span class="n">DefeasibleRule</span><span class="p">(</span><span class="mi">3</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;a&#39;</span><span class="p">]},</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;p&#39;</span><span class="p">],</span> <span class="s1">&#39;d3&#39;</span><span class="p">)</span>
    <span class="n">defeasible_rules</span> <span class="o">=</span> <span class="p">[</span><span class="n">d1</span><span class="p">,</span> <span class="n">d2</span><span class="p">,</span> <span class="n">d3</span><span class="p">]</span>

    <span class="k">if</span> <span class="n">include_d</span><span class="p">:</span>
        <span class="n">defeasible_rules</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">DefeasibleRule</span><span class="p">(</span><span class="mi">4</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;~d&#39;</span><span class="p">]},</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;s&#39;</span><span class="p">],</span> <span class="s1">&#39;d4&#39;</span><span class="p">))</span>

    <span class="k">for</span> <span class="n">defeasible_rule</span> <span class="ow">in</span> <span class="n">defeasible_rules</span><span class="p">:</span>
        <span class="n">defeasible_rule_literal</span> <span class="o">=</span> <span class="n">Literal</span><span class="o">.</span><span class="n">from_defeasible_rule</span><span class="p">(</span><span class="n">defeasible_rule</span><span class="p">)</span>
        <span class="n">defeasible_rule_literal_negation</span> <span class="o">=</span> <span class="n">Literal</span><span class="o">.</span><span class="n">from_defeasible_rule_negation</span><span class="p">(</span><span class="n">defeasible_rule</span><span class="p">)</span>
        <span class="n">language</span><span class="p">[</span><span class="nb">str</span><span class="p">(</span><span class="n">defeasible_rule_literal</span><span class="p">)]</span> <span class="o">=</span> <span class="n">defeasible_rule_literal</span>
        <span class="n">language</span><span class="p">[</span><span class="nb">str</span><span class="p">(</span><span class="n">defeasible_rule_literal_negation</span><span class="p">)]</span> <span class="o">=</span> <span class="n">defeasible_rule_literal_negation</span>
        <span class="n">contraries</span><span class="p">[</span><span class="nb">str</span><span class="p">(</span><span class="n">defeasible_rule_literal</span><span class="p">)]</span> <span class="o">=</span> <span class="p">[</span><span class="n">defeasible_rule_literal_negation</span><span class="p">]</span>
        <span class="n">contraries</span><span class="p">[</span><span class="nb">str</span><span class="p">(</span><span class="n">defeasible_rule_literal_negation</span><span class="p">)]</span> <span class="o">=</span> <span class="p">[</span><span class="n">defeasible_rule_literal</span><span class="p">]</span>

    <span class="k">if</span> <span class="n">include_e</span><span class="p">:</span>
        <span class="n">strict_rules</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">StrictRule</span><span class="p">(</span><span class="mi">2</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;r&#39;</span><span class="p">]},</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;-d3&#39;</span><span class="p">],</span> <span class="s1">&#39;r2&#39;</span><span class="p">))</span>

    <span class="n">arg_sys</span> <span class="o">=</span> <span class="n">ArgumentationSystem</span><span class="p">(</span><span class="n">language</span><span class="p">,</span> <span class="n">contraries</span><span class="p">,</span> <span class="n">strict_rules</span><span class="p">,</span> <span class="n">defeasible_rules</span><span class="p">)</span>

    <span class="n">axioms</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">ordinary_premises</span> <span class="o">=</span> <span class="p">[</span><span class="n">language</span><span class="p">[</span><span class="n">literal_str</span><span class="p">]</span> <span class="k">for</span> <span class="n">literal_str</span> <span class="ow">in</span> <span class="p">[</span><span class="s1">&#39;a&#39;</span><span class="p">,</span> <span class="s1">&#39;r&#39;</span><span class="p">,</span> <span class="s1">&#39;-r&#39;</span><span class="p">,</span> <span class="s1">&#39;~s&#39;</span><span class="p">]]</span>

    <span class="k">if</span> <span class="n">include_d</span><span class="p">:</span>
        <span class="n">ordinary_premises</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;~d&#39;</span><span class="p">])</span>

    <span class="k">for</span> <span class="n">ordinary_premise</span> <span class="ow">in</span> <span class="n">ordinary_premises</span><span class="p">:</span>
        <span class="n">ordinary_premise</span><span class="o">.</span><span class="vm">__class__</span> <span class="o">=</span> <span class="n">OrdinaryPremise</span>

    <span class="n">arg_theory</span> <span class="o">=</span> <span class="n">ArgumentationTheory</span><span class="p">(</span><span class="n">arg_sys</span><span class="p">,</span> <span class="n">axioms</span><span class="p">,</span> <span class="n">ordinary_premises</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">arg_theory</span>


<span class="k">class</span> <span class="nc">TestModgilPrakkenAIJ</span><span class="p">(</span><span class="n">unittest</span><span class="o">.</span><span class="n">TestCase</span><span class="p">):</span>
    <span class="k">def</span> <span class="nf">test_contradiction_function</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="n">arg_theory</span> <span class="o">=</span> <span class="n">get_argumentation_theory</span><span class="p">()</span>
        <span class="n">a</span> <span class="o">=</span> <span class="n">arg_theory</span><span class="o">.</span><span class="n">argumentation_system</span><span class="o">.</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;a&#39;</span><span class="p">]</span>
        <span class="n">naf_a</span> <span class="o">=</span> <span class="n">arg_theory</span><span class="o">.</span><span class="n">argumentation_system</span><span class="o">.</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;~a&#39;</span><span class="p">]</span>
        <span class="n">neg_a</span> <span class="o">=</span> <span class="n">arg_theory</span><span class="o">.</span><span class="n">argumentation_system</span><span class="o">.</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;-a&#39;</span><span class="p">]</span>
        <span class="n">naf_neg_a</span> <span class="o">=</span> <span class="n">arg_theory</span><span class="o">.</span><span class="n">argumentation_system</span><span class="o">.</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;~-a&#39;</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertIn</span><span class="p">(</span><span class="n">a</span><span class="p">,</span> <span class="n">neg_a</span><span class="o">.</span><span class="n">contraries</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertIn</span><span class="p">(</span><span class="n">a</span><span class="p">,</span> <span class="n">naf_a</span><span class="o">.</span><span class="n">contraries</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertIn</span><span class="p">(</span><span class="n">neg_a</span><span class="p">,</span> <span class="n">a</span><span class="o">.</span><span class="n">contraries</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertIn</span><span class="p">(</span><span class="n">neg_a</span><span class="p">,</span> <span class="n">naf_neg_a</span><span class="o">.</span><span class="n">contraries</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertNotIn</span><span class="p">(</span><span class="n">naf_a</span><span class="p">,</span> <span class="n">a</span><span class="o">.</span><span class="n">contraries</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertNotIn</span><span class="p">(</span><span class="n">naf_neg_a</span><span class="p">,</span> <span class="n">neg_a</span><span class="o">.</span><span class="n">contraries</span><span class="p">)</span>

    <span class="k">def</span> <span class="nf">test_arguments</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="n">arg_theory</span> <span class="o">=</span> <span class="n">get_argumentation_theory</span><span class="p">()</span>
        <span class="n">language</span> <span class="o">=</span> <span class="n">arg_theory</span><span class="o">.</span><span class="n">argumentation_system</span><span class="o">.</span><span class="n">language</span>
        <span class="n">args_per_literal</span> <span class="o">=</span> <span class="n">arg_theory</span><span class="o">.</span><span class="n">arguments</span>
        <span class="n">all_args</span> <span class="o">=</span> <span class="nb">set</span><span class="p">()</span><span class="o">.</span><span class="n">union</span><span class="p">(</span><span class="o">*</span><span class="n">args_per_literal</span><span class="o">.</span><span class="n">values</span><span class="p">())</span>
        <span class="n">arg_a_prime</span> <span class="o">=</span> <span class="n">InstantiatedArgument</span><span class="o">.</span><span class="n">observation_based</span><span class="p">(</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;a&#39;</span><span class="p">])</span>
        <span class="n">arg_a</span> <span class="o">=</span> <span class="n">InstantiatedArgument</span><span class="o">.</span><span class="n">defeasible_rule_based</span><span class="p">(</span>
            <span class="n">DefeasibleRule</span><span class="p">(</span><span class="mi">3</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;a&#39;</span><span class="p">]},</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;p&#39;</span><span class="p">],</span> <span class="s1">&#39;d3&#39;</span><span class="p">),</span> <span class="p">{</span><span class="n">arg_a_prime</span><span class="p">})</span>
        <span class="n">arg_b1</span> <span class="o">=</span> <span class="n">InstantiatedArgument</span><span class="o">.</span><span class="n">observation_based</span><span class="p">(</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;~s&#39;</span><span class="p">])</span>
        <span class="n">arg_b1_prime</span> <span class="o">=</span> <span class="n">InstantiatedArgument</span><span class="o">.</span><span class="n">defeasible_rule_based</span><span class="p">(</span>
            <span class="n">DefeasibleRule</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;~s&#39;</span><span class="p">]},</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;t&#39;</span><span class="p">],</span> <span class="s1">&#39;d1&#39;</span><span class="p">),</span> <span class="p">{</span><span class="n">arg_b1</span><span class="p">})</span>
        <span class="n">arg_b2</span> <span class="o">=</span> <span class="n">InstantiatedArgument</span><span class="o">.</span><span class="n">observation_based</span><span class="p">(</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;r&#39;</span><span class="p">])</span>
        <span class="n">arg_b2_prime</span> <span class="o">=</span> <span class="n">InstantiatedArgument</span><span class="o">.</span><span class="n">defeasible_rule_based</span><span class="p">(</span>
            <span class="n">DefeasibleRule</span><span class="p">(</span><span class="mi">2</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;r&#39;</span><span class="p">]},</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;q&#39;</span><span class="p">],</span> <span class="s1">&#39;d2&#39;</span><span class="p">),</span> <span class="p">{</span><span class="n">arg_b2</span><span class="p">})</span>
        <span class="n">arg_b</span> <span class="o">=</span> <span class="n">InstantiatedArgument</span><span class="o">.</span><span class="n">strict_rule_based</span><span class="p">(</span>
            <span class="n">StrictRule</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;t&#39;</span><span class="p">],</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;q&#39;</span><span class="p">]},</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;-p&#39;</span><span class="p">],</span> <span class="s1">&#39;r1&#39;</span><span class="p">),</span> <span class="p">{</span><span class="n">arg_b2_prime</span><span class="p">,</span> <span class="n">arg_b1_prime</span><span class="p">})</span>
        <span class="n">arg_c</span> <span class="o">=</span> <span class="n">InstantiatedArgument</span><span class="o">.</span><span class="n">observation_based</span><span class="p">(</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;-r&#39;</span><span class="p">])</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">assertListEqual</span><span class="p">(</span><span class="nb">sorted</span><span class="p">(</span><span class="n">all_args</span><span class="p">),</span>
                             <span class="nb">sorted</span><span class="p">([</span><span class="n">arg_a_prime</span><span class="p">,</span> <span class="n">arg_a</span><span class="p">,</span> <span class="n">arg_b1</span><span class="p">,</span> <span class="n">arg_b1_prime</span><span class="p">,</span> <span class="n">arg_b2</span><span class="p">,</span> <span class="n">arg_b2_prime</span><span class="p">,</span> <span class="n">arg_b</span><span class="p">,</span> <span class="n">arg_c</span><span class="p">]))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertSetEqual</span><span class="p">(</span><span class="n">arg_b</span><span class="o">.</span><span class="n">premises</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;~s&#39;</span><span class="p">],</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;r&#39;</span><span class="p">]})</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertEqual</span><span class="p">(</span><span class="n">arg_b</span><span class="o">.</span><span class="n">conclusion</span><span class="p">,</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;-p&#39;</span><span class="p">])</span>
        <span class="c1"># Note: incorrect in paper!</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertSetEqual</span><span class="p">(</span><span class="n">arg_b</span><span class="o">.</span><span class="n">sub_arguments</span><span class="p">,</span> <span class="p">{</span><span class="n">arg_b1</span><span class="p">,</span> <span class="n">arg_b2</span><span class="p">,</span> <span class="n">arg_b1_prime</span><span class="p">,</span> <span class="n">arg_b2_prime</span><span class="p">,</span> <span class="n">arg_b</span><span class="p">})</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertEqual</span><span class="p">(</span><span class="n">arg_b</span><span class="o">.</span><span class="n">top_rule</span><span class="p">,</span> <span class="n">StrictRule</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;t&#39;</span><span class="p">],</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;q&#39;</span><span class="p">]},</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;-p&#39;</span><span class="p">],</span> <span class="s1">&#39;r1&#39;</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertSetEqual</span><span class="p">(</span><span class="n">arg_b</span><span class="o">.</span><span class="n">defeasible_rules</span><span class="p">,</span> <span class="p">{</span>
            <span class="n">DefeasibleRule</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;~s&#39;</span><span class="p">]},</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;t&#39;</span><span class="p">],</span> <span class="s1">&#39;d1&#39;</span><span class="p">),</span>
            <span class="n">DefeasibleRule</span><span class="p">(</span><span class="mi">2</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;r&#39;</span><span class="p">]},</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;q&#39;</span><span class="p">],</span> <span class="s1">&#39;d2&#39;</span><span class="p">)</span>
        <span class="p">})</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertSetEqual</span><span class="p">(</span><span class="n">arg_b</span><span class="o">.</span><span class="n">strict_rules</span><span class="p">,</span> <span class="p">{</span><span class="n">StrictRule</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;t&#39;</span><span class="p">],</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;q&#39;</span><span class="p">]},</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;-p&#39;</span><span class="p">],</span> <span class="s1">&#39;r1&#39;</span><span class="p">)})</span>

        <span class="c1"># Test attacks</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">rebuts</span><span class="p">(</span><span class="n">arg_b</span><span class="p">,</span> <span class="n">arg_a</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">undermines</span><span class="p">(</span><span class="n">arg_c</span><span class="p">,</span> <span class="n">arg_b2_prime</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">undermines</span><span class="p">(</span><span class="n">arg_c</span><span class="p">,</span> <span class="n">arg_b2</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">undermines</span><span class="p">(</span><span class="n">arg_b2</span><span class="p">,</span> <span class="n">arg_c</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertFalse</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">attacks</span><span class="p">(</span><span class="n">arg_a</span><span class="p">,</span> <span class="n">arg_b</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertFalse</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">attacks</span><span class="p">(</span><span class="n">arg_b</span><span class="p">,</span> <span class="n">arg_c</span><span class="p">))</span>

        <span class="n">arg_theory</span> <span class="o">=</span> <span class="n">get_argumentation_theory</span><span class="p">(</span><span class="n">include_d</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
        <span class="n">language</span> <span class="o">=</span> <span class="n">arg_theory</span><span class="o">.</span><span class="n">argumentation_system</span><span class="o">.</span><span class="n">language</span>
        <span class="n">arg_d1</span> <span class="o">=</span> <span class="n">InstantiatedArgument</span><span class="o">.</span><span class="n">observation_based</span><span class="p">(</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;~d&#39;</span><span class="p">])</span>
        <span class="n">arg_d2</span> <span class="o">=</span> <span class="n">InstantiatedArgument</span><span class="o">.</span><span class="n">defeasible_rule_based</span><span class="p">(</span><span class="n">DefeasibleRule</span><span class="p">(</span><span class="mi">4</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;~d&#39;</span><span class="p">]},</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;s&#39;</span><span class="p">],</span> <span class="s1">&#39;d4&#39;</span><span class="p">),</span>
                                                            <span class="p">{</span><span class="n">arg_d1</span><span class="p">})</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">contrary_undermines</span><span class="p">(</span><span class="n">arg_d2</span><span class="p">,</span> <span class="n">arg_b</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">contrary_undermines</span><span class="p">(</span><span class="n">arg_d2</span><span class="p">,</span> <span class="n">arg_b1</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">contrary_undermines</span><span class="p">(</span><span class="n">arg_d2</span><span class="p">,</span> <span class="n">arg_b1_prime</span><span class="p">))</span>

        <span class="n">arg_theory</span> <span class="o">=</span> <span class="n">get_argumentation_theory</span><span class="p">(</span><span class="n">include_d</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">include_e</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
        <span class="n">arg_e</span> <span class="o">=</span> <span class="n">InstantiatedArgument</span><span class="o">.</span><span class="n">strict_rule_based</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">argumentation_system</span><span class="o">.</span><span class="n">strict_rules</span><span class="p">[</span><span class="mi">1</span><span class="p">],</span> <span class="p">{</span><span class="n">arg_b2</span><span class="p">})</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">undercuts</span><span class="p">(</span><span class="n">arg_e</span><span class="p">,</span> <span class="n">arg_a</span><span class="p">))</span>

        <span class="c1"># Test defeats</span>
        <span class="n">d1</span> <span class="o">=</span> <span class="n">DefeasibleRule</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;~s&#39;</span><span class="p">]},</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;t&#39;</span><span class="p">],</span> <span class="s1">&#39;d1&#39;</span><span class="p">)</span>
        <span class="n">d2</span> <span class="o">=</span> <span class="n">DefeasibleRule</span><span class="p">(</span><span class="mi">2</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;r&#39;</span><span class="p">]},</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;q&#39;</span><span class="p">],</span> <span class="s1">&#39;d2&#39;</span><span class="p">)</span>
        <span class="n">d3</span> <span class="o">=</span> <span class="n">DefeasibleRule</span><span class="p">(</span><span class="mi">3</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;a&#39;</span><span class="p">]},</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;p&#39;</span><span class="p">],</span> <span class="s1">&#39;d3&#39;</span><span class="p">)</span>

        <span class="n">arg_theory</span><span class="o">.</span><span class="n">argumentation_system</span><span class="o">.</span><span class="n">add_rule_preference</span><span class="p">(</span><span class="n">Preference</span><span class="p">(</span><span class="n">d2</span><span class="p">,</span> <span class="s1">&#39;&lt;&#39;</span><span class="p">,</span> <span class="n">d3</span><span class="p">))</span>
        <span class="n">arg_theory</span><span class="o">.</span><span class="n">add_ordinary_premise_preference</span><span class="p">(</span><span class="n">Preference</span><span class="p">(</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;-r&#39;</span><span class="p">],</span> <span class="s1">&#39;&lt;&#39;</span><span class="p">,</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;r&#39;</span><span class="p">]))</span>
        <span class="c1"># arg_theory.add_ordinary_queryable_preference(Preference(language[&#39;-a&#39;], &#39;=&#39;, language[&#39;r&#39;]))</span>
        <span class="n">arg_theory</span><span class="o">.</span><span class="n">add_ordinary_premise_preference</span><span class="p">(</span><span class="n">Preference</span><span class="p">(</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;~s&#39;</span><span class="p">],</span> <span class="s1">&#39;&lt;&#39;</span><span class="p">,</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;-r&#39;</span><span class="p">]))</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">assertSetEqual</span><span class="p">(</span><span class="n">arg_a</span><span class="o">.</span><span class="n">defeasible_rules</span><span class="p">,</span> <span class="n">arg_a</span><span class="o">.</span><span class="n">last_defeasible_rules</span><span class="p">,</span> <span class="p">{</span><span class="n">d3</span><span class="p">})</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertSetEqual</span><span class="p">(</span><span class="n">arg_a</span><span class="o">.</span><span class="n">ordinary_premises</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;a&#39;</span><span class="p">]})</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertSetEqual</span><span class="p">(</span><span class="n">arg_a_prime</span><span class="o">.</span><span class="n">defeasible_rules</span><span class="p">,</span> <span class="n">arg_a_prime</span><span class="o">.</span><span class="n">last_defeasible_rules</span><span class="p">,</span> <span class="nb">set</span><span class="p">())</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertSetEqual</span><span class="p">(</span><span class="n">arg_a_prime</span><span class="o">.</span><span class="n">ordinary_premises</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;a&#39;</span><span class="p">]})</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertSetEqual</span><span class="p">(</span><span class="n">arg_b</span><span class="o">.</span><span class="n">defeasible_rules</span><span class="p">,</span> <span class="n">arg_b</span><span class="o">.</span><span class="n">last_defeasible_rules</span><span class="p">,</span> <span class="p">{</span><span class="n">d1</span><span class="p">,</span> <span class="n">d2</span><span class="p">})</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertSetEqual</span><span class="p">(</span><span class="n">arg_b</span><span class="o">.</span><span class="n">ordinary_premises</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;~s&#39;</span><span class="p">],</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;r&#39;</span><span class="p">]})</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertSetEqual</span><span class="p">(</span><span class="n">arg_b2</span><span class="o">.</span><span class="n">defeasible_rules</span><span class="p">,</span> <span class="n">arg_b2</span><span class="o">.</span><span class="n">last_defeasible_rules</span><span class="p">,</span> <span class="nb">set</span><span class="p">())</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertSetEqual</span><span class="p">(</span><span class="n">arg_b2</span><span class="o">.</span><span class="n">ordinary_premises</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;r&#39;</span><span class="p">]})</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertSetEqual</span><span class="p">(</span><span class="n">arg_c</span><span class="o">.</span><span class="n">defeasible_rules</span><span class="p">,</span> <span class="n">arg_c</span><span class="o">.</span><span class="n">last_defeasible_rules</span><span class="p">,</span> <span class="nb">set</span><span class="p">())</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertSetEqual</span><span class="p">(</span><span class="n">arg_c</span><span class="o">.</span><span class="n">premises</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;-r&#39;</span><span class="p">]})</span>

        <span class="n">eli</span> <span class="o">=</span> <span class="n">ElitistOrdering</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">argumentation_system</span><span class="o">.</span><span class="n">rule_preference_dict</span><span class="p">,</span>
                              <span class="n">arg_theory</span><span class="o">.</span><span class="n">ordinary_premise_preference_dict</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="n">eli</span><span class="o">.</span><span class="n">rule_set_is_strictly_weaker_than</span><span class="p">(</span><span class="n">arg_b</span><span class="o">.</span><span class="n">last_defeasible_rules</span><span class="p">,</span> <span class="n">arg_a</span><span class="o">.</span><span class="n">last_defeasible_rules</span><span class="p">))</span>
        <span class="n">ell</span> <span class="o">=</span> <span class="n">LastLinkElitistOrdering</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">argumentation_system</span><span class="o">.</span><span class="n">rule_preference_dict</span><span class="p">,</span>
                                      <span class="n">arg_theory</span><span class="o">.</span><span class="n">ordinary_premise_preference_dict</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="n">ell</span><span class="o">.</span><span class="n">argument_is_strictly_weaker_than</span><span class="p">(</span><span class="n">arg_b</span><span class="p">,</span> <span class="n">arg_a</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="n">eli</span><span class="o">.</span><span class="n">rule_set_is_strictly_weaker_than</span><span class="p">(</span><span class="n">arg_b</span><span class="o">.</span><span class="n">defeasible_rules</span><span class="p">,</span> <span class="n">arg_a</span><span class="o">.</span><span class="n">defeasible_rules</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertFalse</span><span class="p">(</span><span class="n">eli</span><span class="o">.</span><span class="n">ordinary_premise_set_is_strictly_weaker_than</span><span class="p">(</span><span class="n">arg_b</span><span class="o">.</span><span class="n">ordinary_premises</span><span class="p">,</span>
                                                                          <span class="n">arg_a</span><span class="o">.</span><span class="n">ordinary_premises</span><span class="p">))</span>
        <span class="n">ewl</span> <span class="o">=</span> <span class="n">WeakestLinkElitistOrdering</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">argumentation_system</span><span class="o">.</span><span class="n">rule_preference_dict</span><span class="p">,</span>
                                         <span class="n">arg_theory</span><span class="o">.</span><span class="n">ordinary_premise_preference_dict</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertFalse</span><span class="p">(</span><span class="n">ewl</span><span class="o">.</span><span class="n">argument_is_strictly_weaker_than</span><span class="p">(</span><span class="n">arg_b</span><span class="p">,</span> <span class="n">arg_a</span><span class="p">))</span>
        <span class="n">dll</span> <span class="o">=</span> <span class="n">LastLinkDemocraticOrdering</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">argumentation_system</span><span class="o">.</span><span class="n">rule_preference_dict</span><span class="p">,</span>
                                         <span class="n">arg_theory</span><span class="o">.</span><span class="n">ordinary_premise_preference_dict</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertFalse</span><span class="p">(</span><span class="n">dll</span><span class="o">.</span><span class="n">argument_is_strictly_weaker_than</span><span class="p">(</span><span class="n">arg_b</span><span class="p">,</span> <span class="n">arg_a</span><span class="p">))</span>
        <span class="n">dwl</span> <span class="o">=</span> <span class="n">WeakestLinkDemocraticOrdering</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">argumentation_system</span><span class="o">.</span><span class="n">rule_preference_dict</span><span class="p">,</span>
                                            <span class="n">arg_theory</span><span class="o">.</span><span class="n">ordinary_premise_preference_dict</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertFalse</span><span class="p">(</span><span class="n">dwl</span><span class="o">.</span><span class="n">argument_is_strictly_weaker_than</span><span class="p">(</span><span class="n">arg_b</span><span class="p">,</span> <span class="n">arg_a</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="n">ell</span><span class="o">.</span><span class="n">argument_is_strictly_weaker_than</span><span class="p">(</span><span class="n">arg_c</span><span class="p">,</span> <span class="n">arg_b2</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="n">ewl</span><span class="o">.</span><span class="n">argument_is_strictly_weaker_than</span><span class="p">(</span><span class="n">arg_c</span><span class="p">,</span> <span class="n">arg_b2</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="n">dll</span><span class="o">.</span><span class="n">argument_is_strictly_weaker_than</span><span class="p">(</span><span class="n">arg_c</span><span class="p">,</span> <span class="n">arg_b2</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="n">dwl</span><span class="o">.</span><span class="n">argument_is_strictly_weaker_than</span><span class="p">(</span><span class="n">arg_c</span><span class="p">,</span> <span class="n">arg_b2</span><span class="p">))</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">assertFalse</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">defeats</span><span class="p">(</span><span class="n">arg_b</span><span class="p">,</span> <span class="n">arg_a</span><span class="p">,</span> <span class="n">ell</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertFalse</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">defeats</span><span class="p">(</span><span class="n">arg_c</span><span class="p">,</span> <span class="n">arg_b</span><span class="p">,</span> <span class="n">ell</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertFalse</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">defeats</span><span class="p">(</span><span class="n">arg_c</span><span class="p">,</span> <span class="n">arg_b2_prime</span><span class="p">,</span> <span class="n">ell</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">defeats</span><span class="p">(</span><span class="n">arg_b2</span><span class="p">,</span> <span class="n">arg_c</span><span class="p">,</span> <span class="n">ell</span><span class="p">))</span>

        <span class="n">arg_d1</span> <span class="o">=</span> <span class="n">InstantiatedArgument</span><span class="o">.</span><span class="n">observation_based</span><span class="p">(</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;~d&#39;</span><span class="p">])</span>
        <span class="n">arg_d2</span> <span class="o">=</span> <span class="n">InstantiatedArgument</span><span class="o">.</span><span class="n">defeasible_rule_based</span><span class="p">(</span><span class="n">DefeasibleRule</span><span class="p">(</span><span class="mi">4</span><span class="p">,</span> <span class="p">{</span><span class="n">language</span><span class="p">[</span><span class="s1">&#39;~d&#39;</span><span class="p">]},</span> <span class="n">language</span><span class="p">[</span><span class="s1">&#39;s&#39;</span><span class="p">],</span> <span class="s1">&#39;d4&#39;</span><span class="p">),</span>
                                                            <span class="p">{</span><span class="n">arg_d1</span><span class="p">})</span>
        <span class="n">arg_e</span> <span class="o">=</span> <span class="n">InstantiatedArgument</span><span class="o">.</span><span class="n">strict_rule_based</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">argumentation_system</span><span class="o">.</span><span class="n">strict_rules</span><span class="p">[</span><span class="mi">1</span><span class="p">],</span> <span class="p">{</span><span class="n">arg_b2</span><span class="p">})</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">defeats</span><span class="p">(</span><span class="n">arg_d2</span><span class="p">,</span> <span class="n">arg_b1_prime</span><span class="p">,</span> <span class="n">ell</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">defeats</span><span class="p">(</span><span class="n">arg_d2</span><span class="p">,</span> <span class="n">arg_b</span><span class="p">,</span> <span class="n">ell</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">defeats</span><span class="p">(</span><span class="n">arg_d2</span><span class="p">,</span> <span class="n">arg_b1</span><span class="p">,</span> <span class="n">ell</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="n">arg_theory</span><span class="o">.</span><span class="n">defeats</span><span class="p">(</span><span class="n">arg_e</span><span class="p">,</span> <span class="n">arg_a</span><span class="p">,</span> <span class="n">ell</span><span class="p">))</span>
</pre></div>
</div>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="installation.html" class="btn btn-neutral float-left" title="Installation instructions" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="modules.html" class="btn btn-neutral float-right" title="PyArg Module Overview" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2022, AnneMarie Borg and Daphne Odekerken.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>